922b1ef536350fb91ba5988fdde991e1fdf7d79a
[notmuch] / test / test-lib.sh
1 #!/usr/bin/env bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
29 done,*)
30         # do not redirect again
31         ;;
32 *' --tee '*|*' --va'*)
33         mkdir -p test-results
34         BASE=test-results/$(basename "$0" .sh)
35         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36          echo $? > $BASE.exit) | tee $BASE.out
37         test "$(cat $BASE.exit)" = 0
38         exit
39         ;;
40 esac
41
42 # Keep the original TERM for say_color
43 ORIGINAL_TERM=$TERM
44
45 # For repeatability, reset the environment to known value.
46 LANG=C
47 LC_ALL=C
48 PAGER=cat
49 TZ=UTC
50 TERM=dumb
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$color"; then
120         say_color () {
121                 (
122                 TERM=$ORIGINAL_TERM
123                 export TERM
124                 case "$1" in
125                         error) tput bold; tput setaf 1;; # bold red
126                         skip)  tput bold; tput setaf 2;; # bold green
127                         pass)  tput setaf 2;;            # green
128                         info)  tput setaf 3;;            # brown
129                         *) test -n "$quiet" && return;;
130                 esac
131                 shift
132                 printf " "
133                 printf "$@"
134                 tput sgr0
135                 )
136         }
137 else
138         say_color() {
139                 test -z "$1" && test -n "$quiet" && return
140                 shift
141                 printf " "
142                 printf "$@"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*\n"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "Tests ${test_description}"
162         exit 0
163 fi
164
165 echo $(basename "$0"): "Testing ${test_description}"
166
167 exec 5>&1
168
169 test_failure=0
170 test_count=0
171 test_fixed=0
172 test_broken=0
173 test_success=0
174
175 die () {
176         code=$?
177         if test -n "$GIT_EXIT_OK"
178         then
179                 exit $code
180         else
181                 echo >&5 "FATAL: Unexpected exit with code $code"
182                 exit 1
183         fi
184 }
185
186 GIT_EXIT_OK=
187 trap 'die' EXIT
188
189 test_decode_color () {
190         sed     -e 's/.\[1m/<WHITE>/g' \
191                 -e 's/.\[31m/<RED>/g' \
192                 -e 's/.\[32m/<GREEN>/g' \
193                 -e 's/.\[33m/<YELLOW>/g' \
194                 -e 's/.\[34m/<BLUE>/g' \
195                 -e 's/.\[35m/<MAGENTA>/g' \
196                 -e 's/.\[36m/<CYAN>/g' \
197                 -e 's/.\[m/<RESET>/g'
198 }
199
200 q_to_nul () {
201         perl -pe 'y/Q/\000/'
202 }
203
204 q_to_cr () {
205         tr Q '\015'
206 }
207
208 append_cr () {
209         sed -e 's/$/Q/' | tr Q '\015'
210 }
211
212 remove_cr () {
213         tr '\015' Q | sed -e 's/Q$//'
214 }
215
216 # Notmuch helper functions
217 increment_mtime_amount=0
218 increment_mtime ()
219 {
220     dir="$1"
221
222     increment_mtime_amount=$((increment_mtime_amount + 1))
223     touch -d "+${increment_mtime_amount} seconds" "$dir"
224 }
225
226 # Generate a new message in the mail directory, with a unique message
227 # ID and subject. The message is not added to the index.
228 #
229 # After this function returns, the filename of the generated message
230 # is available as $gen_msg_filename and the message ID is available as
231 # $gen_msg_id .
232 #
233 # This function supports named parameters with the bash syntax for
234 # assigning a value to an associative array ([name]=value). The
235 # supported parameters are:
236 #
237 #  [dir]=directory/of/choice
238 #
239 #       Generate the message in directory 'directory/of/choice' within
240 #       the mail store. The directory will be created if necessary.
241 #
242 #  [filename]=name
243 #
244 #       Store the message in file 'name'. The default is to store it
245 #       in 'msg-<count>', where <count> is three-digit number of the
246 #       message.
247 #       
248 #  [body]=text
249 #
250 #       Text to use as the body of the email message
251 #
252 #  '[from]="Some User <user@example.com>"'
253 #  '[to]="Some User <user@example.com>"'
254 #  '[subject]="Subject of email message"'
255 #  '[date]="RFC 822 Date"'
256 #
257 #       Values for email headers. If not provided, default values will
258 #       be generated instead.
259 #
260 #  '[cc]="Some User <user@example.com>"'
261 #  [reply-to]=some-address
262 #  [in-reply-to]=<message-id>
263 #  [references]=<message-id>
264 #  [content-type]=content-type-specification
265 #  '[header]=full header line, including keyword'
266 #
267 #       Additional values for email headers. If these are not provided
268 #       then the relevant headers will simply not appear in the
269 #       message.
270 #
271 #  '[id]=message-id'
272 #
273 #       Controls the message-id of the created message.
274 gen_msg_cnt=0
275 gen_msg_filename=""
276 gen_msg_id=""
277 generate_message ()
278 {
279     # This is our (bash-specific) magic for doing named parameters
280     local -A template="($@)"
281     local additional_headers
282
283     gen_msg_cnt=$((gen_msg_cnt + 1))
284     if [ -z "${template[filename]}" ]; then
285         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
286     else
287         gen_msg_name=${template[filename]}
288     fi
289
290     if [ -z "${template[id]}" ]; then
291         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
292     else
293         gen_msg_id="${template[id]}"
294     fi
295
296     if [ -z "${template[dir]}" ]; then
297         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
298     else
299         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
300         mkdir -p "$(dirname "$gen_msg_filename")"
301     fi
302
303     if [ -z "${template[body]}" ]; then
304         template[body]="This is just a test message (#${gen_msg_cnt})"
305     fi
306
307     if [ -z "${template[from]}" ]; then
308         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
309     fi
310
311     if [ -z "${template[to]}" ]; then
312         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
313     fi
314
315     if [ -z "${template[subject]}" ]; then
316         template[subject]="Test message #${gen_msg_cnt}"
317     fi
318
319     if [ -z "${template[date]}" ]; then
320         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
321     fi
322
323     additional_headers=""
324     if [ ! -z "${template[header]}" ]; then
325         additional_headers="${template[header]}
326 ${additional_headers}"
327     fi
328
329     if [ ! -z "${template[reply-to]}" ]; then
330         additional_headers="Reply-To: ${template[reply-to]}
331 ${additional_headers}"
332     fi
333
334     if [ ! -z "${template[in-reply-to]}" ]; then
335         additional_headers="In-Reply-To: ${template[in-reply-to]}
336 ${additional_headers}"
337     fi
338
339     if [ ! -z "${template[cc]}" ]; then
340         additional_headers="Cc: ${template[cc]}
341 ${additional_headers}"
342     fi
343
344     if [ ! -z "${template[references]}" ]; then
345         additional_headers="References: ${template[references]}
346 ${additional_headers}"
347     fi
348
349     if [ ! -z "${template[content-type]}" ]; then
350         additional_headers="Content-Type: ${template[content-type]}
351 ${additional_headers}"
352     fi
353
354     # Note that in the way we're setting it above and using it below,
355     # `additional_headers' will also serve as the header / body separator
356     # (empty line in between).
357
358     cat <<EOF >"$gen_msg_filename"
359 From: ${template[from]}
360 To: ${template[to]}
361 Message-Id: <${gen_msg_id}>
362 Subject: ${template[subject]}
363 Date: ${template[date]}
364 ${additional_headers}
365 ${template[body]}
366 EOF
367
368     # Ensure that the mtime of the containing directory is updated
369     increment_mtime "$(dirname "${gen_msg_filename}")"
370 }
371
372 # Generate a new message and add it to the database.
373 #
374 # All of the arguments and return values supported by generate_message
375 # are also supported here, so see that function for details.
376 add_message ()
377 {
378     generate_message "$@" &&
379     notmuch new > /dev/null
380 }
381
382 # Deliver a message with emacs and add it to the database
383 #
384 # Uses emacs to generate and deliver a message to the mail store.
385 # Accepts arbitrary extra emacs/elisp functions to modify the message
386 # before sending, which is useful to doing things like attaching files
387 # to the message and encrypting/signing.
388 emacs_deliver_message ()
389 {
390     local subject="$1"
391     local body="$2"
392     shift 2
393     # before we can send a message, we have to prepare the FCC maildir
394     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
395     ../smtp-dummy sent_message &
396     smtp_dummy_pid=$!
397     test_emacs "(setq message-send-mail-function 'message-smtpmail-send-it) (setq smtpmail-smtp-server \"localhost\") (setq smtpmail-smtp-service \"25025\") (notmuch-hello) (notmuch-mua-mail) (message-goto-to) (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\") (message-goto-subject) (insert \"${subject}\") (message-goto-body) (insert \"${body}\") $@ (message-send-and-exit)" >/dev/null 2>&1
398     wait ${smtp_dummy_pid}
399     notmuch new >/dev/null
400 }
401
402 # Generate a corpus of email and add it to the database.
403 #
404 # This corpus is fixed, (it happens to be 50 messages from early in
405 # the history of the notmuch mailing list), which allows for reliably
406 # testing commands that need to operate on a not-totally-trivial
407 # number of messages.
408 add_email_corpus ()
409 {
410     rm -rf ${MAIL_DIR}
411     if [ -d ../corpus.mail ]; then
412         cp -a ../corpus.mail ${MAIL_DIR}
413     else
414         cp -a ../corpus ${MAIL_DIR}
415         notmuch new >/dev/null
416         cp -a ${MAIL_DIR} ../corpus.mail
417     fi
418 }
419
420 test_begin_subtest ()
421 {
422     if [ -n "$inside_subtest" ]; then
423         exec 1>&6 2>&7          # Restore stdout and stderr
424         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
425     fi
426     test_subtest_name="$1"
427     # Remember stdout and stderr file descriptios and redirect test
428     # output to the previously prepared file descriptors 3 and 4 (see
429     # below)
430     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
431     exec 6>&1 7>&2 >&3 2>&4
432     inside_subtest=t
433 }
434
435 # Pass test if two arguments match
436 #
437 # Note: Unlike all other test_expect_* functions, this function does
438 # not accept a test name. Instead, the caller should call
439 # test_begin_subtest before calling this function in order to set the
440 # name.
441 test_expect_equal ()
442 {
443         exec 1>&6 2>&7          # Restore stdout and stderr
444         inside_subtest=
445         test "$#" = 3 && { prereq=$1; shift; } || prereq=
446         test "$#" = 2 ||
447         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
448
449         output="$1"
450         expected="$2"
451         if ! test_skip "$@"
452         then
453                 if [ "$output" = "$expected" ]; then
454                         test_ok_ "$test_subtest_name"
455                 else
456                         testname=$this_test.$test_count
457                         echo "$expected" > $testname.expected
458                         echo "$output" > $testname.output
459                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
460                 fi
461     fi
462 }
463
464 test_expect_equal_file ()
465 {
466         exec 1>&6 2>&7          # Restore stdout and stderr
467         inside_subtest=
468         test "$#" = 3 && { prereq=$1; shift; } || prereq=
469         test "$#" = 2 ||
470         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
471
472         output="$1"
473         expected="$2"
474         if ! test_skip "$@"
475         then
476                 if diff -q "$expected" "$output" >/dev/null ; then
477                         test_ok_ "$test_subtest_name"
478                 else
479                         testname=$this_test.$test_count
480                         mv "$output" $testname.output
481                         mv "$expected" $testname.expected
482                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
483                 fi
484     fi
485 }
486
487 test_expect_equal_failure ()
488 {
489         exec 1>&6 2>&7          # Restore stdout and stderr
490         inside_subtest=
491         test "$#" = 3 && { prereq=$1; shift; } || prereq=
492         test "$#" = 2 ||
493         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
494
495         output="$1"
496         expected="$2"
497         if ! test_skip "$@"
498         then
499                 if [ "$output" = "$expected" ]; then
500                         test_known_broken_ok_ "$test_subtest_name"
501                 else
502                         test_known_broken_failure_ "$test_subtest_name"
503                         testname=$this_test.$test_count
504                         echo "$expected" > $testname.expected
505                         echo "$output" > $testname.output
506                 fi
507     fi
508 }
509
510 NOTMUCH_NEW ()
511 {
512     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
513 }
514
515 notmuch_search_sanitize ()
516 {
517     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
518 }
519
520 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
521 notmuch_show_sanitize ()
522 {
523     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
524 }
525 notmuch_show_sanitize_all ()
526 {
527     sed \
528         -e 's| filename:.*| filename:XXXXX|' \
529         -e 's| id:[^ ]* | id:XXXXX |'
530 }
531
532 notmuch_json_show_sanitize ()
533 {
534     sed -e 's|, |,\n |g' | \
535         sed \
536         -e 's|"id": "[^"]*",|"id": "XXXXX",|' \
537         -e 's|"filename": "[^"]*",|"filename": "YYYYY",|'
538 }
539
540 # End of notmuch helper functions
541
542 # Use test_set_prereq to tell that a particular prerequisite is available.
543 # The prerequisite can later be checked for in two ways:
544 #
545 # - Explicitly using test_have_prereq.
546 #
547 # - Implicitly by specifying the prerequisite tag in the calls to
548 #   test_expect_{success,failure,code}.
549 #
550 # The single parameter is the prerequisite tag (a simple word, in all
551 # capital letters by convention).
552
553 test_set_prereq () {
554         satisfied="$satisfied$1 "
555 }
556 satisfied=" "
557
558 test_have_prereq () {
559         case $satisfied in
560         *" $1 "*)
561                 : yes, have it ;;
562         *)
563                 ! : nope ;;
564         esac
565 }
566
567 # You are not expected to call test_ok_ and test_failure_ directly, use
568 # the text_expect_* functions instead.
569
570 test_ok_ () {
571         test_success=$(($test_success + 1))
572         say_color pass "%-6s" "PASS"
573         echo " $@"
574 }
575
576 test_failure_ () {
577         test_failure=$(($test_failure + 1))
578         say_color error "%-6s" "FAIL"
579         echo " $1"
580         shift
581         echo "$@" | sed -e 's/^/        /'
582         if test "$verbose" != "t"; then cat test.output; fi
583         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
584 }
585
586 test_known_broken_ok_ () {
587         test_fixed=$(($test_fixed+1))
588         say_color pass "%-6s" "FIXED"
589         echo " $@"
590 }
591
592 test_known_broken_failure_ () {
593         test_broken=$(($test_broken+1))
594         say_color pass "%-6s" "BROKEN"
595         echo " $@"
596 }
597
598 test_debug () {
599         test "$debug" = "" || eval "$1"
600 }
601
602 test_run_ () {
603         test_cleanup=:
604         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
605         eval >&3 2>&4 "$1"
606         eval_ret=$?
607         eval >&3 2>&4 "$test_cleanup"
608         return 0
609 }
610
611 test_skip () {
612         test_count=$(($test_count+1))
613         to_skip=
614         for skp in $NOTMUCH_SKIP_TESTS
615         do
616                 case $this_test.$test_count in
617                 $skp)
618                         to_skip=t
619                 esac
620         done
621         if test -z "$to_skip" && test -n "$prereq" &&
622            ! test_have_prereq "$prereq"
623         then
624                 to_skip=t
625         fi
626         case "$to_skip" in
627         t)
628                 say_color skip >&3 "skipping test: $@"
629                 say_color skip "%-6s" "SKIP"
630                 echo " $1"
631                 : true
632                 ;;
633         *)
634                 false
635                 ;;
636         esac
637 }
638
639 test_expect_failure () {
640         test "$#" = 3 && { prereq=$1; shift; } || prereq=
641         test "$#" = 2 ||
642         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
643         if ! test_skip "$@"
644         then
645                 test_run_ "$2"
646                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
647                 then
648                         test_known_broken_ok_ "$1"
649                 else
650                         test_known_broken_failure_ "$1"
651                 fi
652         fi
653 }
654
655 test_expect_success () {
656         test "$#" = 3 && { prereq=$1; shift; } || prereq=
657         test "$#" = 2 ||
658         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
659         if ! test_skip "$@"
660         then
661                 test_run_ "$2"
662                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
663                 then
664                         test_ok_ "$1"
665                 else
666                         test_failure_ "$@"
667                 fi
668         fi
669 }
670
671 test_expect_code () {
672         test "$#" = 4 && { prereq=$1; shift; } || prereq=
673         test "$#" = 3 ||
674         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
675         if ! test_skip "$@"
676         then
677                 test_run_ "$3"
678                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
679                 then
680                         test_ok_ "$2"
681                 else
682                         test_failure_ "$@"
683                 fi
684         fi
685 }
686
687 # test_external runs external test scripts that provide continuous
688 # test output about their progress, and succeeds/fails on
689 # zero/non-zero exit code.  It outputs the test output on stdout even
690 # in non-verbose mode, and announces the external script with "* run
691 # <n>: ..." before running it.  When providing relative paths, keep in
692 # mind that all scripts run in "trash directory".
693 # Usage: test_external description command arguments...
694 # Example: test_external 'Perl API' perl ../path/to/test.pl
695 test_external () {
696         test "$#" = 4 && { prereq=$1; shift; } || prereq=
697         test "$#" = 3 ||
698         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
699         descr="$1"
700         shift
701         if ! test_skip "$descr" "$@"
702         then
703                 # Announce the script to reduce confusion about the
704                 # test output that follows.
705                 say_color "" " run $test_count: $descr ($*)"
706                 # Run command; redirect its stderr to &4 as in
707                 # test_run_, but keep its stdout on our stdout even in
708                 # non-verbose mode.
709                 "$@" 2>&4
710                 if [ "$?" = 0 ]
711                 then
712                         test_ok_ "$descr"
713                 else
714                         test_failure_ "$descr" "$@"
715                 fi
716         fi
717 }
718
719 # Like test_external, but in addition tests that the command generated
720 # no output on stderr.
721 test_external_without_stderr () {
722         # The temporary file has no (and must have no) security
723         # implications.
724         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
725         stderr="$tmp/git-external-stderr.$$.tmp"
726         test_external "$@" 4> "$stderr"
727         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
728         descr="no stderr: $1"
729         shift
730         if [ ! -s "$stderr" ]; then
731                 rm "$stderr"
732                 test_ok_ "$descr"
733         else
734                 if [ "$verbose" = t ]; then
735                         output=`echo; echo Stderr is:; cat "$stderr"`
736                 else
737                         output=
738                 fi
739                 # rm first in case test_failure exits.
740                 rm "$stderr"
741                 test_failure_ "$descr" "$@" "$output"
742         fi
743 }
744
745 # This is not among top-level (test_expect_success | test_expect_failure)
746 # but is a prefix that can be used in the test script, like:
747 #
748 #       test_expect_success 'complain and die' '
749 #           do something &&
750 #           do something else &&
751 #           test_must_fail git checkout ../outerspace
752 #       '
753 #
754 # Writing this as "! git checkout ../outerspace" is wrong, because
755 # the failure could be due to a segv.  We want a controlled failure.
756
757 test_must_fail () {
758         "$@"
759         test $? -gt 0 -a $? -le 129 -o $? -gt 192
760 }
761
762 # test_cmp is a helper function to compare actual and expected output.
763 # You can use it like:
764 #
765 #       test_expect_success 'foo works' '
766 #               echo expected >expected &&
767 #               foo >actual &&
768 #               test_cmp expected actual
769 #       '
770 #
771 # This could be written as either "cmp" or "diff -u", but:
772 # - cmp's output is not nearly as easy to read as diff -u
773 # - not all diff versions understand "-u"
774
775 test_cmp() {
776         $GIT_TEST_CMP "$@"
777 }
778
779 # This function can be used to schedule some commands to be run
780 # unconditionally at the end of the test to restore sanity:
781 #
782 #       test_expect_success 'test core.capslock' '
783 #               git config core.capslock true &&
784 #               test_when_finished "git config --unset core.capslock" &&
785 #               hello world
786 #       '
787 #
788 # That would be roughly equivalent to
789 #
790 #       test_expect_success 'test core.capslock' '
791 #               git config core.capslock true &&
792 #               hello world
793 #               git config --unset core.capslock
794 #       '
795 #
796 # except that the greeting and config --unset must both succeed for
797 # the test to pass.
798
799 test_when_finished () {
800         test_cleanup="{ $*
801                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
802 }
803
804 test_done () {
805         GIT_EXIT_OK=t
806         test_results_dir="$TEST_DIRECTORY/test-results"
807         mkdir -p "$test_results_dir"
808         test_results_path="$test_results_dir/${0%.sh}-$$"
809
810         echo "total $test_count" >> $test_results_path
811         echo "success $test_success" >> $test_results_path
812         echo "fixed $test_fixed" >> $test_results_path
813         echo "broken $test_broken" >> $test_results_path
814         echo "failed $test_failure" >> $test_results_path
815         echo "" >> $test_results_path
816
817         echo
818
819         if [ "$test_failure" = "0" ]; then
820             if [ "$test_broken" = "0" ]; then       
821                 rm -rf "$remove_tmp"
822             fi
823             exit 0
824         else
825             exit 1
826         fi
827 }
828
829 test_emacs () {
830         # Construct a little test script here for the benefit of the user,
831         # (who can easily run "run_emacs" to get the same emacs environment
832         # for investigating any failures).    
833         cat <<EOF > run_emacs
834 #!/bin/sh
835 export PATH=$PATH
836 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
837
838 # We assume that the user will give a command-line argument only if
839 # wanting to run in batch mode.
840 if [ \$# -gt 0 ]; then
841         BATCH=--batch
842 fi
843
844 # Here's what we are using here:
845 #
846 # --batch:              Quit after given commands and print all (messages)
847 #
848 # --no-init-file        Don't load users ~/.emacs
849 #
850 # --no-site-file        Don't load the site-wide startup stuff
851 #
852 # --directory           Ensure that the local elisp sources are found
853 #
854 # --load                Force loading of notmuch.el and test-lib.el
855 #
856 # notmuch-test-wait     Function for tests to use to wait for process completion
857 #
858 # message-signature     Avoiding appending user's signature on messages
859 #
860 # set-frame-width       80 columns (avoids crazy 10-column default of --batch)
861
862 emacs \$BATCH --no-init-file --no-site-file \
863         --directory ../../emacs --load notmuch.el \
864         --directory .. --load test-lib.el \
865         --eval "(defun notmuch-test-wait ()
866                         (while (get-buffer-process (current-buffer))
867                                 (sleep-for 0.1)))" \
868         --eval "(setq message-signature nil)" \
869         --eval "(progn (set-frame-width (window-frame (get-buffer-window)) 80) \$@)"
870 EOF
871         chmod a+x ./run_emacs
872         ./run_emacs "$@"
873 }
874
875
876 find_notmuch_path ()
877 {
878     dir="$1"
879
880     while [ -n "$dir" ]; do
881         bin="$dir/notmuch"
882         if [ -x "$bin" ]; then
883             echo "$dir"
884             return
885         fi
886         dir="$(dirname "$dir")"
887         if [ "$dir" = "/" ]; then
888             break
889         fi
890     done
891 }
892
893 # Test the binaries we have just built.  The tests are kept in
894 # test/ subdirectory and are run in 'trash directory' subdirectory.
895 TEST_DIRECTORY=$(pwd)
896 if test -n "$valgrind"
897 then
898         make_symlink () {
899                 test -h "$2" &&
900                 test "$1" = "$(readlink "$2")" || {
901                         # be super paranoid
902                         if mkdir "$2".lock
903                         then
904                                 rm -f "$2" &&
905                                 ln -s "$1" "$2" &&
906                                 rm -r "$2".lock
907                         else
908                                 while test -d "$2".lock
909                                 do
910                                         say "Waiting for lock on $2."
911                                         sleep 1
912                                 done
913                         fi
914                 }
915         }
916
917         make_valgrind_symlink () {
918                 # handle only executables
919                 test -x "$1" || return
920
921                 base=$(basename "$1")
922                 symlink_target=$TEST_DIRECTORY/../$base
923                 # do not override scripts
924                 if test -x "$symlink_target" &&
925                     test ! -d "$symlink_target" &&
926                     test "#!" != "$(head -c 2 < "$symlink_target")"
927                 then
928                         symlink_target=../valgrind.sh
929                 fi
930                 case "$base" in
931                 *.sh|*.perl)
932                         symlink_target=../unprocessed-script
933                 esac
934                 # create the link, or replace it if it is out of date
935                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
936         }
937
938         # override notmuch executable in TEST_DIRECTORY/..
939         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
940         mkdir -p "$GIT_VALGRIND"/bin
941         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
942         OLDIFS=$IFS
943         IFS=:
944         for path in $PATH
945         do
946                 ls "$path"/notmuch 2> /dev/null |
947                 while read file
948                 do
949                         make_valgrind_symlink "$file"
950                 done
951         done
952         IFS=$OLDIFS
953         PATH=$GIT_VALGRIND/bin:$PATH
954         GIT_EXEC_PATH=$GIT_VALGRIND/bin
955         export GIT_VALGRIND
956 else # normal case
957         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
958         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
959 fi
960 export PATH
961
962 # Test repository
963 test="tmp.$(basename "$0" .sh)"
964 test -n "$root" && test="$root/$test"
965 case "$test" in
966 /*) TMP_DIRECTORY="$test" ;;
967  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
968 esac
969 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
970 rm -fr "$test" || {
971         GIT_EXIT_OK=t
972         echo >&5 "FATAL: Cannot prepare test area"
973         exit 1
974 }
975
976 MAIL_DIR="${TMP_DIRECTORY}/mail"
977 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
978 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
979
980 mkdir -p "${test}"
981 mkdir -p "${MAIL_DIR}"
982
983 cat <<EOF >"${NOTMUCH_CONFIG}"
984 [database]
985 path=${MAIL_DIR}
986
987 [user]
988 name=Notmuch Test Suite
989 primary_email=test_suite@notmuchmail.org
990 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
991 EOF
992
993
994 # Use -P to resolve symlinks in our working directory so that the cwd
995 # in subprocesses like git equals our $PWD (for pathname comparisons).
996 cd -P "$test" || error "Cannot setup test environment"
997
998 if test "$verbose" = "t"
999 then
1000         exec 4>&2 3>&1
1001 else
1002         exec 4>test.output 3>&4
1003 fi
1004
1005 this_test=${0##*/}
1006 for skp in $NOTMUCH_SKIP_TESTS
1007 do
1008         to_skip=
1009         for skp in $NOTMUCH_SKIP_TESTS
1010         do
1011                 case "$this_test" in
1012                 $skp)
1013                         to_skip=t
1014                 esac
1015         done
1016         case "$to_skip" in
1017         t)
1018                 say_color skip >&3 "skipping test $this_test altogether"
1019                 say_color skip "skip all tests in $this_test"
1020                 test_done
1021         esac
1022 done
1023
1024 # Provide an implementation of the 'yes' utility
1025 yes () {
1026         if test $# = 0
1027         then
1028                 y=y
1029         else
1030                 y="$*"
1031         fi
1032
1033         while echo "$y"
1034         do
1035                 :
1036         done
1037 }
1038
1039 # Fix some commands on Windows
1040 case $(uname -s) in
1041 *MINGW*)
1042         # Windows has its own (incompatible) sort and find
1043         sort () {
1044                 /usr/bin/sort "$@"
1045         }
1046         find () {
1047                 /usr/bin/find "$@"
1048         }
1049         sum () {
1050                 md5sum "$@"
1051         }
1052         # git sees Windows-style pwd
1053         pwd () {
1054                 builtin pwd -W
1055         }
1056         # no POSIX permissions
1057         # backslashes in pathspec are converted to '/'
1058         # exec does not inherit the PID
1059         ;;
1060 *)
1061         test_set_prereq POSIXPERM
1062         test_set_prereq BSLASHPSPEC
1063         test_set_prereq EXECKEEPSPID
1064         ;;
1065 esac
1066
1067 test -z "$NO_PERL" && test_set_prereq PERL
1068 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1069
1070 # test whether the filesystem supports symbolic links
1071 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1072 rm -f y